module Hxt where

import Text.XML.HXT.Arrow
import System.Environment (getArgs)


test1 = readDocument [] "heise-atom.xml" >>> 
        elemSel "title" >>>
        gatherText


test2 = readDocument [] "contacts.xml" >>>
        processChildren (processDocumentRootElement `when` isElem) >>>
        writeDocument [(a_indent, v_1)] "simple_contacts.xml" >>>
        getErrStatus

gatherText = (listA (deep isText >>> getText) >>> arr concat)

elemSel nm = deep $ isElem >>> hasNameWith (\ n-> localPart n == nm)

        
-- Task: 
-- * collapse <street> and <number> to <address>
-- * remove all but the "general" phone entry
-- * remove <email> entries
processDocumentRootElement = 
    setElemName (mkName "simplecontacts") >>>
    processChildren (removeEmail >>> collapseAddress >>> filterPhone)
  where removeEmail = processChildren (none `when` (isElem >>> hasName "email"))
        addrElem = isElem >>> (hasName "street" <+> hasName "number")
        collapseAddress = 
          insertChildrenAfter (isText `orElse` hasName "firstname" `orElse`hasName "name")
            (selem "address" [elemSel "street" >>> deep isText, 
                              arr (const " ") >>> mkText, 
                              elemSel "number" >>> deep isText]) >>>
          processChildren (none `when` addrElem)
        filterPhone = 
          processChildren (none `when` (isElem >>> 
                                        hasName "phone" >>> 
                                        hasAttrValue "type" (/="general")))


main :: IO ()
main = do args <- getArgs
          case args of
            ["one"] -> do ts <- runX test1
                          mapM_ putStrLn ts
            ["two"] -> do i <- runX test2
                          putStrLn $ "Transformation error code: "++(show i)

